﻿
namespace WP7Host.Web.Service
{
    using System.Data;
    using System.Data.Objects;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;
    using WP7Host.Web;


    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class WP7DomainService : LinqToEntitiesDomainService<WP7ModelContainer>
    {

        [Query(IsDefault = true)]
        public IQueryable<WP7History> GetWP7HistorySet()
        {
            return this.ObjectContext.WP7HistorySet;
        }

        /// <summary>
        /// 조회를 하면서 동시에 히스토리 데이터도 조회 한다.
        /// 점진적 로드를 위해 id로 정렬
        /// </summary>
        /// <returns></returns>
        [Query(IsDefault = true)]
        public IQueryable<WP7UriList> GetWP7UriListSet()
        {
            var query = (
                            (ObjectQuery<WP7UriList>)
                                from kkk in this.ObjectContext.WP7UriListSet
                                orderby kkk.Id
                                select kkk
                        ).Include("WP7History");
            //return this.ObjectContext.WP7UriListSet;
            return query.AsQueryable();
        }

        public void InsertWP7UriList(WP7UriList wP7UriList)
        {
            if ((wP7UriList.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(wP7UriList, EntityState.Added);
            }
            else
            {
                this.ObjectContext.WP7UriListSet.AddObject(wP7UriList);
            }
        }

        public void UpdateWP7UriList(WP7UriList currentWP7UriList)
        {
            this.ObjectContext.WP7UriListSet.AttachAsModified(currentWP7UriList, this.ChangeSet.GetOriginal(currentWP7UriList));
        }

        public void DeleteWP7UriList(WP7UriList wP7UriList)
        {
            if ((wP7UriList.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(wP7UriList, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.WP7UriListSet.Attach(wP7UriList);
                this.ObjectContext.WP7UriListSet.DeleteObject(wP7UriList);
            }
        }
    }
}


